/*
** graphics library interface 
** modified 3/14/09 for experimenter
** added bit map capability
**
*/


#define HRES 128
#define VRES 64
#define Home()      { cx=0; cy=0;}
#define Clrscr()    { clearScreen(); Home();}
#define AT( x, y)   { cx = (x); cy = (y);}
    
#define readSPI()   writeSPI( 0xFF)
extern int cx, cy;
unsigned char writeSPI( unsigned char b);
void putcV( int a);

void putsV( unsigned char *s);
void drawbitmap32x32 ( long unsigned *slp,unsigned char xoff, unsigned char yoff);





void initSD( void);     // initializes the I/O pins for the SD/MMC interface 
unsigned char writeSPI( unsigned char b);
void enableCS(void);

void disableCS(void);
void setAO(void);

void clearA0(void);

void clearDisplay(void);
void clearVmap( void);
void dumpVmap( void);
void clearScreen (void);
void line( int x0, int y0, int x1, int y1);
void plotxsinx(void);
void random_line_demo( void);
void Rectangle ( int left, int top, int right, int bottom);
void Circle ( int xcenter, int ycenter, int radius);
void Bar ( int left, int top, int right, int bottom);
void Triangle ( int topx, int topy, int rightx, int righty) ;
void IsoTriangle ( int topx, int topy, int rightx, int righty);

void goto_xy(char x, char y);